# SwaggerClient-php
## REST API for Upbit Exchange - Base URL: [https://api.upbit.com] - Official Upbit API Documents: [https://docs.upbit.com] - Official Support email: [open-api@upbit.com]

This PHP package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0
- Build package: io.swagger.codegen.languages.PhpClientCodegen
For more information, please visit [https://github.com/uJhin](https://github.com/uJhin)

## Requirements

PHP 5.5 and later

## Installation & Usage
### Composer

To install the bindings via [Composer](http://getcomposer.org/), add the following to `composer.json`:

```
{
  "repositories": [
    {
      "type": "git",
      "url": "https://github.com//.git"
    }
  ],
  "require": {
    "/": "*@dev"
  }
}
```

Then run `composer install`

### Manual Installation

Download the files and include `autoload.php`:

```php
    require_once('/path/to/SwaggerClient-php/vendor/autoload.php');
```

## Tests

To run the unit tests:

```
composer install
./vendor/bin/phpunit
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```php
<?php
require_once(__DIR__ . '/vendor/autoload.php');

// Configure API key authorization: Bearer
$config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKey('Authorization', 'YOUR_API_KEY');
// Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
// $config = Swagger\Client\Configuration::getDefaultConfiguration()->setApiKeyPrefix('Authorization', 'Bearer');

$apiInstance = new Swagger\Client\Api\APIKeyApi(
    // If you want use custom http client, pass your client which implements `GuzzleHttp\ClientInterface`.
    // This is optional, `GuzzleHttp\Client` will be used as default.
    new GuzzleHttp\Client(),
    $config
);

try {
    $result = $apiInstance->aPIKeyInfo();
    print_r($result);
} catch (Exception $e) {
    echo 'Exception when calling APIKeyApi->aPIKeyInfo: ', $e->getMessage(), PHP_EOL;
}

?>
```

## Documentation for API Endpoints

All URIs are relative to *https://api.upbit.com/v1*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*APIKeyApi* | [**aPIKeyInfo**](docs/Api/APIKeyApi.md#apikeyinfo) | **GET** /api_keys | API 키 리스트 조회
*AccountApi* | [**accountInfo**](docs/Api/AccountApi.md#accountinfo) | **GET** /accounts | 전체 계좌 조회
*AccountApi* | [**accountWallet**](docs/Api/AccountApi.md#accountwallet) | **GET** /status/wallet | 입출금 현황
*CandleApi* | [**candleDays**](docs/Api/CandleApi.md#candledays) | **GET** /candles/days | 시세 캔들 조회 (일 단위)
*CandleApi* | [**candleMinutes**](docs/Api/CandleApi.md#candleminutes) | **GET** /candles/minutes/{unit} | 시세 캔들 조회 (분 단위)
*CandleApi* | [**candleMonth**](docs/Api/CandleApi.md#candlemonth) | **GET** /candles/months | 시세 캔들 조회 (월 단위)
*CandleApi* | [**candleWeeks**](docs/Api/CandleApi.md#candleweeks) | **GET** /candles/weeks | 시세 캔들 조회 (주 단위)
*DepositApi* | [**depositCoinAddress**](docs/Api/DepositApi.md#depositcoinaddress) | **GET** /deposits/coin_address | 개별 입금 주소 조회
*DepositApi* | [**depositCoinAddresses**](docs/Api/DepositApi.md#depositcoinaddresses) | **GET** /deposits/coin_addresses | 전체 입금 주소 조회
*DepositApi* | [**depositGenerateCoinAddress**](docs/Api/DepositApi.md#depositgeneratecoinaddress) | **POST** /deposits/generate_coin_address | 입금 주소 생성 요청
*DepositApi* | [**depositInfo**](docs/Api/DepositApi.md#depositinfo) | **GET** /deposit | 개별 입금 조회
*DepositApi* | [**depositInfoAll**](docs/Api/DepositApi.md#depositinfoall) | **GET** /deposits | 입금 리스트 조회
*MarketApi* | [**marketInfoAll**](docs/Api/MarketApi.md#marketinfoall) | **GET** /market/all | 마켓 코드 조회
*OrderApi* | [**orderCancel**](docs/Api/OrderApi.md#ordercancel) | **DELETE** /order | 주문 취소 접수
*OrderApi* | [**orderChance**](docs/Api/OrderApi.md#orderchance) | **GET** /orders/chance | 주문 가능 정보
*OrderApi* | [**orderInfo**](docs/Api/OrderApi.md#orderinfo) | **GET** /order | 개별 주문 조회
*OrderApi* | [**orderInfoAll**](docs/Api/OrderApi.md#orderinfoall) | **GET** /orders | 주문 리스트 조회
*OrderApi* | [**orderNew**](docs/Api/OrderApi.md#ordernew) | **POST** /orders | 주문하기
*OrderApi* | [**orderOrderbook**](docs/Api/OrderApi.md#orderorderbook) | **GET** /orderbook | 시세 호가 정보(Orderbook) 조회
*TradeApi* | [**tradeTicker**](docs/Api/TradeApi.md#tradeticker) | **GET** /ticker | 시세 Ticker 조회
*TradeApi* | [**tradeTicks**](docs/Api/TradeApi.md#tradeticks) | **GET** /trades/ticks | 시세 체결 조회
*WithdrawApi* | [**withdrawChance**](docs/Api/WithdrawApi.md#withdrawchance) | **GET** /withdraws/chance | 출금 가능 정보
*WithdrawApi* | [**withdrawCoin**](docs/Api/WithdrawApi.md#withdrawcoin) | **POST** /withdraws/coin | 코인 출금하기
*WithdrawApi* | [**withdrawInfo**](docs/Api/WithdrawApi.md#withdrawinfo) | **GET** /withdraw | 개별 출금 조회
*WithdrawApi* | [**withdrawInfoAll**](docs/Api/WithdrawApi.md#withdrawinfoall) | **GET** /withdraws | 출금 리스트 조회
*WithdrawApi* | [**withdrawKrw**](docs/Api/WithdrawApi.md#withdrawkrw) | **POST** /withdraws/krw | 원화 출금하기


## Documentation For Models

 - [APIKey](docs/Model/APIKey.md)
 - [Account](docs/Model/Account.md)
 - [Ask](docs/Model/Ask.md)
 - [AskAccount](docs/Model/AskAccount.md)
 - [Bid](docs/Model/Bid.md)
 - [BidAccount](docs/Model/BidAccount.md)
 - [CandleDate](docs/Model/CandleDate.md)
 - [CandleDays](docs/Model/CandleDays.md)
 - [CandleMinutes](docs/Model/CandleMinutes.md)
 - [Currency](docs/Model/Currency.md)
 - [Deposit](docs/Model/Deposit.md)
 - [DepositCompleteResponse](docs/Model/DepositCompleteResponse.md)
 - [DepositTransferResponse](docs/Model/DepositTransferResponse.md)
 - [Error](docs/Model/Error.md)
 - [ErrorInfo](docs/Model/ErrorInfo.md)
 - [Market](docs/Model/Market.md)
 - [MarketInfo](docs/Model/MarketInfo.md)
 - [MemberLevel](docs/Model/MemberLevel.md)
 - [NewOrder](docs/Model/NewOrder.md)
 - [Order](docs/Model/Order.md)
 - [OrderChance](docs/Model/OrderChance.md)
 - [OrderInfo](docs/Model/OrderInfo.md)
 - [Orderbook](docs/Model/Orderbook.md)
 - [OrderbookUnit](docs/Model/OrderbookUnit.md)
 - [Ticker](docs/Model/Ticker.md)
 - [Trade](docs/Model/Trade.md)
 - [TradeTicks](docs/Model/TradeTicks.md)
 - [Wallet](docs/Model/Wallet.md)
 - [Withdraw](docs/Model/Withdraw.md)
 - [WithdrawChance](docs/Model/WithdrawChance.md)
 - [WithdrawCoin](docs/Model/WithdrawCoin.md)
 - [WithdrawLimit](docs/Model/WithdrawLimit.md)


## Documentation For Authorization


## Bearer

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author

ujhin942@gmail.com


